-- get current screen size
local screen_width, screen_height = render.get_screen_size( )

-- menu stuff
local fakelag_history_bool = gui.add_checkbox( "Enable fakelag history", "lua>tab a" )
local fakelag_history_color = gui.add_colorpicker( "lua>tab a>enable fakelag history", false, render.color( 5,150,195,255 ) )

-- data
local old_choke = 0
local choke_3 = 0
local choke_2 = 0
local choke_1 = 0
local choke_0 = 0

-- our funky indicator function
local function draw_indicator( )
    local y_coord = screen_height / 2
    local cur_lag = info.fatality.lag_ticks
    local ind_col = fakelag_history_color:get_color( )
    local choke_string = string.format( "%i-%i-%i-%i", choke_3, choke_2, choke_1, choke_0 )

    if cur_lag < old_choke then
        choke_0 = choke_1
        choke_1 = choke_2
        choke_2 = choke_3
        choke_3 = old_choke
    end
    
    old_choke = cur_lag

    render.text( render.font_indicator, 10, y_coord - 20, choke_string, ind_col, render.align_left, render.align_center )
end

-- lets draw it!
function on_paint( )
    local local_player = entities.get_entity( engine.get_local_player( ) )
    if not engine.is_in_game( ) or not local_player:is_valid( ) or not fakelag_history_bool:get_bool( ) then
        return
    end

    draw_indicator( )
end