local hit_marker_screen = gui.add_checkbox("Hit marker", "visuals>misc>various")
local hit_marker_size_slider = gui.add_slider("Hit marker line size", "visuals>misc>various", 1, 10, 1)
local hit_marker_dist_slider = gui.add_slider("Hit marker line distance", "visuals>misc>various", 0, 10, 1)

local disable_time = 0
local hitmarker_time = 0
local screen_x, screen_y = render.get_screen_size()

function on_player_hurt(event)
    local attacker = event:get_int("attacker")
    local attacker_to_player = engine.get_player_for_user_id(attacker)
    local local_index = engine.get_local_player()
 
    local get_timer = 0.8

    if attacker_to_player == local_index then
        disable_time = global_vars.realtime + get_timer
        hitmarker_time = get_timer
    end
end

function on_paint()
    local get_size = hit_marker_size_slider:get_int()
    local get_distance = hit_marker_dist_slider:get_int()
    
    if disable_time < global_vars.realtime then return end
    local a = get_distance
    local p = 255 * (disable_time - global_vars.realtime) / hitmarker_time
    local b = a + get_size
    local color = render.color(200, 200, 200, math.floor(p))
     
    render.line(screen_x / 2 - b, screen_y / 2 - b, screen_x / 2 - a, screen_y / 2 - a, color) -- left upper
    render.line(screen_x / 2 - b, screen_y / 2 + b, screen_x / 2 - a, screen_y / 2 + a, color) -- left down
    render.line(screen_x / 2 + b, screen_y / 2 + b, screen_x / 2 + a, screen_y / 2 + a, color) -- right down
    render.line(screen_x / 2 + b, screen_y / 2 - b, screen_x / 2 + a, screen_y / 2 - a, color) -- right upper
end