ffi.cdef[[
    typedef struct{
        float x;
        float y;
        float z;
    }Vector;

    typedef struct{
        Vector			m_vPos;
        Vector			m_vAngles;
        int				m_nEntIndex;
        const char		*m_pszSpriteName;
        float			m_flBeamWidth;
        int				m_nBeams;
        Vector			m_vColor;
        float			m_flTimeVisible;
        float			m_flRadius;
    } CTeslaInfo;

    typedef void (__thiscall*FX_TeslaFn)(const CTeslaInfo &teslaInfo);
]]

local FX_Tesla = ffi.cast("FX_TeslaFn",utils.find_pattern("client.dll","55 8B EC 81 ? ? ? ? ? 56 57 8B F9 8B 47 18"));
local TeslaInfo = ffi.new("CTeslaInfo");

gui.add_slider("--Tesla--", "visuals>misc>local", 0, 0, 0)
local BeamWidth_value =  gui.add_slider("BeamWidth", "visuals>misc>local", 40.0, 100.0, 1)
local VisibleTime_value =  gui.add_slider("VisibleTime", "visuals>misc>local", 1.0, 30.0, 1)
local Radius_value =  gui.add_slider("Radius", "visuals>misc>local", 500.0, 1000.0, 100)


function on_bullet_impact(event)
    TeslaInfo.m_vPos.x = event:get_float("x"); 
    TeslaInfo.m_vPos.y = event:get_float("y");
    TeslaInfo.m_vPos.z = event:get_float("z");

    TeslaInfo.m_vAngles.x = 0;
    TeslaInfo.m_vAngles.y = 0;
    TeslaInfo.m_vAngles.z = 0;
    TeslaInfo.m_nEntIndex = 0;
    TeslaInfo.m_pszSpriteName = "sprites/physbeam.vmt";
    TeslaInfo.m_flBeamWidth = BeamWidth_value:get_float()*0.1;
    
    TeslaInfo.m_vColor.x = 1;
    TeslaInfo.m_vColor.y = 1;
    TeslaInfo.m_vColor.z = 1;

    TeslaInfo.m_flTimeVisible = VisibleTime_value:get_float()*0.1;
	TeslaInfo.m_flRadius = Radius_value:get_float();
    TeslaInfo.m_nBeams = 6;
    FX_Tesla(TeslaInfo);
end

--created(pasted) by madman121